// mailthingy.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "./helpers/MimeMessage.h"
#include "./helpers/smtp.h"
#include "mailthingy.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// The one and only application object

CWinApp theApp;

using namespace std;

/* Globals */
char server[256];
char destaddr[256];
char fromaddr[256];
char msg[256];
char subj[256];
char *pMsgID = NULL;

int _tmain(int argc, TCHAR* argv[], TCHAR* envp[]){
	int ret = 0;

	if (!AfxWinInit(::GetModuleHandle(NULL), NULL, ::GetCommandLine(), 0)){
		
		printf("MFC initialization error.  Aborting.\n");
		return -1;
	}//if
	
	if((argc < 4) || (stricmp(argv[1], "--help") == 0)){
		showUsage();
		return 0;
	}//if

	pMsgID = argv[3];
	if(!readSettings(argv[1])){
		printf("Error reading settings from configuration file.  Aborted.\n");
		return 0;
	}//readSettings

	strcpy(destaddr, argv[2]);
	
	if(sendMail()){
		printf("Message sent.\n");
	}//if
	else{
		printf("Error sending message.\n");
	}//else

	return ret;
}//main

void showUsage(){

	printf("Usage: \n");
	printf("       mailthingy <config file> <address> <message id>\n");

}//showUsage


int sendMail(){
	CMIMEMessage mimemsg;
	CSMTP smtp(server);
	int ret = 0;

	mimemsg.SetCharsPerLine(80);
	mimemsg.m_sFrom = fromaddr;
	mimemsg.m_sSubject = subj;
	mimemsg.m_sBody = msg;

	mimemsg.AddRecipient(destaddr);

	if(smtp.Connect()){

		if(smtp.SendMessage(&mimemsg)){
			ret = 1;
		}//if

		smtp.Disconnect();

	}//if

	return ret;
}//sendMail


int readSettings(char *pFilename){

	int ret = 1;
	if(pFilename == NULL)
		return 0;

	memset(server, 0, 256);
	memset(destaddr, 0, 256);
	memset(fromaddr, 0, 256);
	memset(msg, 0, 256);
	memset(subj, 0, 256);

	GetPrivateProfileString("options", "server", "", server, 255, pFilename);
	GetPrivateProfileString("options", pMsgID, "", msg, 255, pFilename);
	GetPrivateProfileString("options", "from", "", fromaddr, 255, pFilename);
	GetPrivateProfileString("options", "subject", "", subj, 255, pFilename);
	
	if( (!strlen(server)) || (!strlen(msg)) || (!strlen(fromaddr)) || (!strlen(subj)) )
		ret = 0;

	return ret;


}//readSettings